#include <pt.h>

#include "LedControlMS.h"
#define sw_leftp1 PIN_PB5
#define sw_rightp1 PIN_PB4
#define sw_leftp2 PIN_PB3
#define sw_rightp2 PIN_PB1
#define sw_start PIN_PB2
#define sw_quit PIN_PB0

#define PT_DELAY(pt, ms, ts)\
    ts = millis();\
    PT_WAIT_WHILE(pt, millis()-ts < (ms));

struct pt pt_taskplayer1;
struct pt pt_taskplayer2;
struct pt pt_taskstartgame;
struct pt pt_taskball;
struct pt pt_taskquit;

byte current1;
byte current2;
int barier1;
int barier2;
int bx;
int by;
int dx;
int dy;
int delayTime;

LedControl lc=LedControl(PIN_PC0, PIN_PC4, PIN_PC2,1);
bool start = false;

///////////////////////////////////////////////
void left(int p, byte current){
  byte next;
  if(current != B11000000){
    next = current<<1;
    if(p==1){
      current1=next;
      lc.setRow(0,0,next);
      barier1--;
    }
    else if(p==2){
      current2=next;
      lc.setRow(0,7,next);
      barier2--;
    }
  }
}

void right(int p, byte current){
  byte next;
  if(current != B00000011){
    next = current>>1;
    if(p==1){
      current1 = next;
      lc.setRow(0,0,next);
      barier1++ ;
    }
    else if(p==2){
      current2=next;
      lc.setRow(0,7,next);
      barier2++;
    }
  }
}
 
///////////////////////////////////////////////////////
PT_THREAD(taskplayer2(struct pt* pt))
{
  static uint32_t ts;
 
  PT_BEGIN(pt);
  while(1){
    if(start){
      while(digitalRead(sw_leftp2) == LOW){
        left(2, current2);
        PT_DELAY(pt, 100, ts);
      }
      while(digitalRead(sw_rightp2) == LOW){
        right(2, current2);
        PT_DELAY(pt, 100, ts);
      }
      PT_YIELD(pt);
    }
    PT_YIELD(pt);
  }
  PT_END(pt);
}
 
///////////////////////////////////////////////////////
PT_THREAD(taskplayer1(struct pt* pt))
{
  static uint32_t ts;
 
  PT_BEGIN(pt);
  while(1){
    if(start){
      while(digitalRead(sw_leftp1) == LOW){
        left(1, current1);
        PT_DELAY(pt, 100, ts);
      }
      while(digitalRead(sw_rightp1) == LOW){
        right(1, current1);
        PT_DELAY(pt, 100, ts);
      }
      PT_YIELD(pt);
    }
    PT_YIELD(pt);
  }
  PT_END(pt);
}

///////////////////////////////////////////////////////
PT_THREAD(taskstartgame(struct pt* pt)){
  static uint32_t ts;
  static byte Go[8]={
    B00011100,
    B00010100,
    B00011100,
    B00000000,
    B00011000,
    B01010100,
    B01000100,
    B00111000};
  static byte one[3]={
    B00000100,
    B01111100,
    B01000100};
  static byte two[4] = {
    B01110100,
    B01010100,
    B01010100,
    B01011100,};
  static byte three[5] = {
    B01010100,
    B01010100,
    B01010100,
    B01111100,
    B00000000};
  
  PT_BEGIN(pt);  
  while(1){
    PT_WAIT_WHILE(pt, digitalRead(sw_start) == HIGH);
    PT_WAIT_WHILE(pt,digitalRead(sw_start) == LOW);
    
    start = false;
    current1 = B00011000;
    current2 = B00011000;
    barier1 = 3;
    barier2 = 3;
    bx = 4;
    by = 4;
    dx = -1;
    dy = 0;
    delayTime = 400;
             
    lc.clearDisplay(0);

    lc.setRow(0,5,three[0]);
    lc.setRow(0,4,three[1]);
    lc.setRow(0,3,three[2]);
    lc.setRow(0,2,three[3]);
    lc.setRow(0,1,three[4]);
    PT_DELAY(pt, 500, ts);
  
    lc.clearDisplay(0);
    
    lc.setRow(0,2,two[0]);
    lc.setRow(0,3,two[1]);
    lc.setRow(0,4,two[2]);
    lc.setRow(0,5,two[3]);
    PT_DELAY(pt, 500, ts);
  
    lc.clearDisplay(0);
  
    lc.setRow(0,2,one[0]);
    lc.setRow(0,3,one[1]);
    lc.setRow(0,4,one[2]);
    PT_DELAY(pt, 500, ts);
  
    lc.clearDisplay(0);
  
    lc.setRow(0,0,Go[0]);
    lc.setRow(0,1,Go[1]);
    lc.setRow(0,2,Go[2]);
    lc.setRow(0,3,Go[3]);
    lc.setRow(0,4,Go[4]);
    lc.setRow(0,5,Go[5]);
    lc.setRow(0,6,Go[6]);
    lc.setRow(0,7,Go[7]);
    PT_DELAY(pt,600, ts);
    
    lc.clearDisplay(0);

    lc.setRow(0,0,current1);
    lc.setRow(0,7,current2);

    start = true;
    
    PT_YIELD(pt);
  }
  PT_END(pt);
}

///////////////////////////////////////////////////////
int next;
PT_THREAD(taskball(struct pt* pt))
{
  static uint32_t ts;
  
  PT_BEGIN(pt);
    while(1){  
      if(start){
        while(1){
          if(!start)break;
          lc.setLed(0,bx,by,true);
          PT_DELAY(pt, delayTime, ts);
          if(!start)break;
          lc.setLed(0,bx,by,false);
          
          if (bx == 1){
            if(by == barier1 || by == barier1+1 || by+dy == barier1 || by+dy == barier1+1){
              dx = dx * (-1);
              if (by == 0) 
                dy = random(-1,1); 
              else if (by == 7) 
                dy = random(0,2);
              else dy = random(-1,2);
              
              if(delayTime > 100)
                delayTime = delayTime*0.9;
            }
            else {
              start = false;
              lc.clearDisplay(0);
              
              PT_YIELD(pt);
              break;
            }
          }
  
          else if (bx == 6){
            if(by == barier2 || by == barier2+1 || by+dy == barier2 || by+dy == barier2+1){
              dx = dx * (-1);
              if (by == 0) 
                dy = random(-1,1);
              else if (by == 7) 
                dy = random(0,2);
              else 
                dy = random(-1,2);
            }
            else {
              start = false;
              lc.clearDisplay(0);
              
              PT_YIELD(pt);
              break;
            }
          }
  
          if (by == 0 || by == 7){
            dy = dy * (-1);
          }
          bx = bx + dx;
          by = by + dy;
          PT_YIELD(pt);
      }
    }
    PT_YIELD(pt);
  }
  PT_END(pt);
}

//////////////////////////////////////////////////////////////////////////////
PT_THREAD(taskquit(struct pt* pt))
{
  static uint32_t ts;
  
  byte heart[9] = {
    B00000000,
    B01100110,
    B10000001,
    B10000001,
    B10000001,
    B01000010,
    B00100100,
    B00011000,
    B10011001};
  
  PT_BEGIN(pt);
  while(1){
    if(start)
    {
      PT_WAIT_WHILE(pt, digitalRead(sw_quit) == HIGH);    
      PT_WAIT_WHILE(pt,digitalRead(sw_quit) == LOW);
      start = false;
      lc.clearDisplay(0);
      
      for(int i = 7; i >= -1; i--){
        if(i == -1)
          lc.setColumn(0,2,heart[8]);
        else{
          lc.setColumn(0,i,heart[i]);
          delay(200);
        }
      }
      delay(1000);
      
      lc.clearDisplay(0);
    }
    PT_YIELD(pt);
  }
  PT_END(pt);
}

///////////////////////////////////////////////////////
void setup()
{
  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,8);
  /* and clear the display */
  lc.clearDisplay(0);
  pinMode(sw_leftp1, INPUT_PULLUP);
  pinMode(sw_rightp1, INPUT_PULLUP);
  pinMode(sw_leftp2, INPUT_PULLUP);
  pinMode(sw_rightp2, INPUT_PULLUP);
  pinMode(sw_start, INPUT_PULLUP);
  pinMode(sw_quit, INPUT_PULLUP);
  PT_INIT(&pt_taskstartgame);
  PT_INIT(&pt_taskplayer1);
  PT_INIT(&pt_taskplayer2);
  PT_INIT(&pt_taskball);
  PT_INIT(&pt_taskquit);
  
}
 
///////////////////////////////////////////////////////
void loop()
{
  taskstartgame(&pt_taskstartgame);
  taskplayer1(&pt_taskplayer1);
  taskplayer2(&pt_taskplayer2);
  taskquit(&pt_taskquit);
  taskball(&pt_taskball);;
}
